import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _Object$entries;
var _excluded = ["design"];
import { forwardRef } from 'react';
import PropTypes from 'prop-types';
import { DESIGN } from '../config.js';
import PrimitiveTypography from '../index.js';
import { jsx as _jsx } from "react/jsx-runtime";
var getDesign = function getDesign(_ref) {
  var design = _ref.design,
    displayName = _ref.displayName;
  var Component = /*#__PURE__*/forwardRef(function (_ref2, forwardedRef) {
    var omittedDesign = _ref2.design,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded);
    return /*#__PURE__*/_jsx(PrimitiveTypography, _extends({
      design: design
    }, props, {
      ref: forwardedRef
    }));
  });
  Component.propTypes = {
    design: PropTypes.oneOf(Object.values(DESIGN))
  };
  Component.displayName = displayName;
  return Component;
};
var Styles = Object.fromEntries(Object.entries((_Object$entries = {}, _Object$entries[DESIGN.DISPLAY_1] = 'Display1', _Object$entries[DESIGN.DISPLAY_2] = 'Display2', _Object$entries[DESIGN.DISPLAY_3] = 'Display3', _Object$entries[DESIGN.HEADLINE_1] = 'Headline1', _Object$entries[DESIGN.HEADLINE_2] = 'Headline2', _Object$entries[DESIGN.SUBHEAD] = 'SubHead', _Object$entries[DESIGN.BODY_1] = 'Body1', _Object$entries[DESIGN.BODY_2] = 'Body2', _Object$entries[DESIGN.CAPTION] = 'Caption', _Object$entries[DESIGN.SMALL] = 'Small', _Object$entries[DESIGN.CALLOUT] = 'Callout', _Object$entries)).map(function (_ref3) {
  var design = _ref3[0],
    name = _ref3[1];
  return [name, getDesign({
    design: design,
    displayName: "PrimitiveTypography" + name
  })];
}));
export default Styles;